<?php

/*
   Das Editieren dieser Datei ist nicht gestattet!
   Editing of this file is not allowed!
*/

/* public */ class bufferedDbStream extends secureFileStream {

  /* private int */       var $database;
  /* private String */    var $last_selected_table = "";
  /* private String[] */  var $content = array();
  /* private Hashtable */ var $cache   = array();
  /* private Hashtable */ var $filter  = array("DEFAULT" => "");
  /* private Hashtable */ var $joins   = array();

  /* constructor */ function bufferedDbStream(/* String */ $filename, /* dbServer */ $server = false) {
    settype($filename, "string");

    if (!$server) $server = new dbServer();
    $this->database       = $server->get();

    if (!file_exists($filename) || !is_readable($filename)) {
      unset($this->source);
      $this->exists = false;
    } else {
      $this->attributes['MTIME'] = date("d.m.Y",filemtime($filename));
      $this->attributes['ATIME'] = date("d.m.Y H:i:s",fileatime($filename));
      $this->attributes['CTIME'] = date("d.m.Y",filectime($filename));
      clearstatcache();
      $this->exists = true;
    }
    global $REMOTE_ADDR; if (isset($REMOTE_ADDR)) { $this->attributes['REMOTE_ADDR'] = $REMOTE_ADDR; }
    $this->filename = $filename;
  }

/**********************************************************************************************
*  Arbeitsfunktionen
**********************************************************************************************/

  /* public boolean */ function read() {
    if (!$this->exists)   return false;
    if (!$this->database) return false;

    $this->source  = getConfigFile($this->filename,false);
    $this->options = $this->attributes;
    if (!isset($this->source['DATABASE'])) $this->source['DATABASE'] = database_name;
    if (!$this->exists = @mysql_select_db($this->source['DATABASE'], $this->database)) {
      echo "<P><b>DATABASE ERROR:</b> Unable to select database &quot;".$this->source['DATABASE']."&quot;</P>";
    }

    return $this->exists;
  }

  /* public void */ function close() {
    if ($this->source) { # can't close a stream that has never been opened!

      $this->failsafeWrite();
      @mysql_close($this->database);
      $this->reset();

    }
  }

  /* public void */ function reset() {
    unset($this->content);
    unset($this->options);
    unset($this->last_selected_table);
    $this->joins  = array();
    $this->filter = array("DEFAULT" => "");
    $this->options = $this->attributes;
  }

  /* public boolean */ function write() {

    if ($this->source['READONLY']) return false;
    if (!$this->source)  return false;

    if (count($this->content) == 0)   # Buffer empty
    {
        return true;
    }
    else if (count($this->content) == 1)  # Buffer contains 1 statement
    {
        if (!@mysql_query($this->content[0], $this->database)) return false;
        $this->content = array();
        return true;
    }
    else  # Buffer contains multiple statements -> start transaction
    {
        if (!@mysql_query("START TRANSACTION;", $this->database)) return false;
        for ($i=0; $i<count($this->content); $i++) {
           if (trim($this->content[$i]) != '' && !@mysql_query($this->content[$i], $this->database))
           {
             if (!@mysql_query("ROLLBACK;", $this->database)) echo "<P><B>SQL ERROR:</B> Critical database error. Unable to rollback changes. Database might contain corrupt data. Please inform webmaster about time of event and anything you might have done to cause this failure.</P>";
             return false;
           }
        }
        if (!@mysql_query("COMMIT;", $this->database)) return false;
        $this->content = array();
        return true;
    }
  }

/**********************************************************************************************
*  Lesen und Schreiben der Datenbank
**********************************************************************************************/

  /* public mixed */ function get(/* String */ $key, /* String */ $search = "", /* String */ $filter = "") {
    settype($key, "string");
    settype($search, "string");
    settype($filter, "string");

    $key = strtolower($key);
    $filter = strtolower($filter);

    if (!$this->database)          return false;
    if (!$this->source)            return false;

    if ($filter){
      $table = explode('/', $key);
      $table = $table[0];
      $old_filter = $this->getFilter($table);
      $this->setFilter($table, $filter);
      $return = $this->computeRequest($key, $search);
      $this->setFilter($table, $old_filter);
      return $return;
    } else {
      return $this->computeRequest($key, $search);
    }
  }

  /* public boolean */ function insert(/* String */ $key, /* mixed */ $value, /* String */ $filter = "") {
    settype($key, "string");
    settype($filter, "string");

    $key = strtolower($key);
    $filter = strtolower($filter);

    if (!$this->database)          return false;
    if ($this->source['READONLY']) return false;
    if (!$this->source)            return false;

    if ($filter){
      $table = explode('/', $key);
      $table = $table[0];
      $old_filter = $this->getFilter($table);
      $this->setFilter($table, $filter);
      if ($this->computeRequest($key, "", $value)) {
        eval("\$this->cache".decodeAdress(strtolower($key))."=\$value;");
        $return = true;
      } else {
        $return = false;
      }
      $this->setFilter($table, $old_filter);
      return $return;
    } else {
      if ($this->computeRequest($key, "", $value)) {
        eval("\$this->cache".decodeAdress(strtolower($key))."=\$value;");
        return true;
      } else {
        return false;
      }
    }

  }

/****************************************************************************************************/


  /* public boolean */ function remove(/* String */ $key, /* String */ $search = "") {
    settype($key, "string");
    settype($search, "string");

    $key = strtolower($key);

    if (!$this->database)          return false;
    if ($this->source['READONLY']) return false;
    if (!$this->source)            return false;

    $key = explode("/", $key);
    settype($key, "array");
    $this->last_selected_table = $key[0];

    if ($search) $search = $this->computeSearchString($key[0], $search);

    if (count($key) < 2 && !$search) return false;
    if (count($key) > 2)             return false;
    if ($key[1] == '0')              return false;

    if ($key[1] == "*") {  # remove last entry
      array_push($this->content,"DELETE FROM ".database_prefix.$key[0].( ($search) ? " WHERE $search " : '' )." ORDER BY ".$this->source['TABLES'][strtolower($key[0])]['PRIMARY_KEY']." DESC LIMIT 1;");
    } else {               # remove entry with id $key[1]
      array_push($this->content,"DELETE FROM ".database_prefix.$key[0]." WHERE ".( (isset($key[1]) && $key[1] != '') ? $this->source['TABLES'][strtolower($key[0])]['PRIMARY_KEY']." = ".$key[1] : '' ).( ($search) ? " $search " : '' ).( (isset($key[1]) && $key[1] != '') ? " LIMIT 1" : "" ).";");
    }

    return true;
  }

  /* public booolean */ function join(/* String */ $table1 = "", /* String */ $table2, /* String */ $key1 = "", /* String */ $key2 = "") {
    settype($table1, "string");
    settype($table2, "string");
    settype($key1,   "string");
    settype($key2,   "string");
    $table1 = strtolower($table1);
    $table2 = strtolower($table2);
    $key1   = strtolower($key1);
    $key2   = strtolower($key2);

    if (!$this->database)          return false;
    if (!$this->source)            return false;

    if (preg_match("/^[\w\d-_]*$|^\*$/i", $table1) &&
        preg_match("/^[\w\d-_]*$/i", $table2)      &&
        preg_match("/^[\w\d-_]*$/i", $key1)        &&
        preg_match("/^[\w\d-_]*$/i", $key2)           )
    
    {

        if ($table1 == "" || $table1 == "*") {
          if (!$this->last_selected_table) {
            return false;
          } else {
            $table1 = $this->last_selected_table;
          }
        }

        if ($this->source['USE_STRICT']) {
        
          if (!$this->source['TABLES'][$table1] || ($table2 && !$this->source['TABLES'][$table2])) {
            echo "<P><B>SQL WARNING:</B> Cannot join tables ".$table1." and ".$table2.". Table does not exist in structure file.</P>";
            return false;
          }
          if ($key1 && !$this->source['TABLES'][$table1]['CONTENT'][$key1]) {
            echo "<P><B>SQL WARNING:</B> Cannot join tables ".$table1." and ".$table2.". Field ".$key1." does not exist in table ".$table1.".</P>";
            return false;
          }
          if ($table2 && $key2 && !$this->source['TABLES'][$table2]['CONTENT'][$key2]) {
            echo "<P><B>SQL WARNING:</B> Cannot join tables ".$table1." and ".$table2.". Field ".$key2." does not exist in table ".$table2.".</P>";
            return false;
          }
        }


        if ($table2) {
                              $this->joins[$table1][$table2]['TABLE'] = $table2;
          if ($key1)          $this->joins[$table1][$table2]['FKEY']  = $key1;
          if ($key1 && $key2) $this->joins[$table1][$table2]['TKEY']  = $key2;
          return true;
        } else {
          $this->joins[$table1] = array();
          return true;
        }

    } else {

      return false;

    }

  }

  /* public mixed */ function query(/* String */ $query) {
    settype($query, "string");
    if (!$this->database) return false;
    if (!$this->source)   return false;

    $query = preg_replace("/;.*/", "", $query);

    return $result = @ mysql_query("SELECT ".$query, $this->database);
  }

/**********************************************************************************************
* Mapping PHP <-> MySQL
**********************************************************************************************/

  /* private mixed */ function computeRequest(/* String */ $key, /* String */ $search = "", /* mixed */ $value = NULL) {

    if (!$this->source)  return false;
    if (!$this->database) return false;

    $key = strtolower($key);

    /* int */ $returnedType = 0; # 0 = unknown, 1 = table, 2 = row, 3 = field
    /* int */ $queryType    = 0; # 0 = unknown, 1 = select, 2 = update, 3 = insert
    /* int */ $useWildcard  = 0; # 0 = none, 1 = foo/*, 2 = foo/*/foo

    # 1) check if input is valid

    settype($key, "string");
    settype($search, "string");
    $key = strtolower($key);
    if (!preg_match("/^((, ?)?([\w\d-_\.])+=([\w\d-_\. ])+)*$/i", $search)) return false;
    if (!preg_match("/^[\w\d-_]+(\/([\w\d-_]*|\*)){0,}(\/\*)?$/i", $key))  return false;

    # 2) prepare input for computation

    if (preg_match("/\/\*?$/", $key)) {
      $useWildcard = 1;
    } else if (preg_match("/[\w\d-_]+\/\*\/([\w\d-_]+)$/i", $key)) {
      $useWildcard = 2;
    } else {
      $useWildcard = 0;
    }

    $key = preg_replace("/\/(\*)?$/", '', $key);
    $keyArray = explode("/", $key);

    # 3) resolve foreign keys to get true adress

    while (count($keyArray) > 3 && $this->source['TABLES'][$keyArray[0]]['FOREIGN_KEYS'][$keyArray[2]]) {
      $a = $this->computeRequest($keyArray[0]."/".$keyArray[1]."/".$keyArray[2]);
      if (!$a) return false;
      $resultType = $this->source['TABLES'][$this->source['TABLES'][$keyArray[0]]['FOREIGN_KEYS'][$keyArray[2]]]['CONTENT'][$keyArray[2]]['TYPE'];
      if ($resultType) {
        @settype($a, $resultType);
      }
      $b = $this->source['TABLES'][$keyArray[0]]['FOREIGN_KEYS'][$keyArray[2]];
      @ array_shift($keyArray); @ array_shift($keyArray); @ array_shift($keyArray);
      array_unshift($keyArray, $a);
      array_unshift($keyArray, $b);
      unset($a);
      unset($b);
      unset($resultType);
    }

    if(count($keyArray) > 3) {
      return false;
    } else {
      $key = implode('/', $keyArray);
      if ($returnedType == 0) $returnedType = count($keyArray);
    }

    # 4) now that there is a resolved adress: if $value is set, check first if it is valid before going on

    if ($returnedType>1) {
      # Let's check the primary key first
      $keyArray[1] = untaintInput($keyArray[1],
      $this->source['TABLES'][$keyArray[0]]['CONTENT'][strtolower($this->source['TABLES'][$keyArray[0]]['PRIMARY_KEY'])]['TYPE'],
      $this->source['TABLES'][$keyArray[0]]['CONTENT'][strtolower($this->source['TABLES'][$keyArray[0]]['PRIMARY_KEY'])]['LENGTH'],
      true);
    }

    if (!is_null($value)) {

          if (!$this->is_writeable()) {
            echo ("<P><B>SQL ERROR:</B> Database is readonly. Insert/Update operation aborted.</P>");
            return false;
          }
          
          if ($returnedType==1 && $useWildcard==1) {
            $returnedType = 2;
            $queryType    = 3;
          }

          if (!$queryType) $queryType = ($this->exists($key)) ? 2 : 3;

          switch ($returnedType) {

            # Inserting/Updating a table
            case 1:
                if ($this->source['USE_STRICT']) echo ("<P><B>SQL ERROR:</B> Inserting/Updating a table is illegal. Operation aborted.</P>");
                return false;
            break;

            # Updating a row
            case 2:
                settype($value, "array");
                $value = array_change_key_case($value, CASE_LOWER);

                # untaint raw data
                foreach ($value as $a => $b) {
                  $value[$a] = untaintInput($b,
                  $this->source['TABLES'][$keyArray[0]]['CONTENT'][$a]['TYPE'],
                  $this->source['TABLES'][$keyArray[0]]['CONTENT'][$a]['LENGTH'],
                  true);
                  # if it is a foreign key, check wether there is a field with that id
                  if ($this->source['TABLES'][$keyArray[0]]['FOREIGN_KEYS'][$a] && !$this->exists($this->source['TABLES'][$keyArray[0]]['FOREIGN_KEYS'][$a].'/'.$b)) {
                    # OK - there is none. Now let's check if there is one recently inserted field in cache
                    $test = false;
                    eval("\$test = isset(\$this->cache[".$this->source['TABLES'][$keyArray[0]]['FOREIGN_KEYS'][$a]."][".$b."]);");
                    if (!$test) {
                      echo "<P><B>SQL Error:</B> The value &quot;".$b."&quot; for attribute &quot;".$a."&quot; refers to a none existing entry in table &quot;".$this->source['TABLES'][$keyArray[0]]['FOREIGN_KEYS'][$a]."&quot;. Insert/Update operation aborted.</P>";
                      return false;                                  
                    }
                    unset($test);
                  }
                }

                # check if all required data is available
                if ($queryType == 3) {
                  foreach ($this->source['TABLES'][$keyArray[0]]['CONTENT'] as $a => $b) {
                    if ($b['REQUIRED'] && ! isset($value[$a])) {
                      if (strcasecmp($b['REQUIRED'], 'auto') == 0) {
                        switch ($b['TYPE']) {
                          case 'time':
                           $value[$a] = time();
                          break;
                          default:
                            $value[$a] = false;
                          break;
                        }
                      } else {
                        echo "<P><B>SQL ERROR:</B> A required attribute &quot;".$a."&quot; has not been provided. Insert/Update operation aborted.</P>";
                        return false;
                      } # IF
                    } # IF
                  } # FOREACH
                } # IF
            break;

            # Updating a field
            case 3:

                # untaint raw data
                $value = untaintInput($value,
                $this->source['TABLES'][$keyArray[0]]['CONTENT'][$keyArray[2]]['TYPE'],
                $this->source['TABLES'][$keyArray[0]]['CONTENT'][$keyArray[2]]['LENGTH'],
                true);

                # if it is a foreign key, check wether there is a field with that id
                if ($this->source['TABLES'][$keyArray[0]]['FOREIGN_KEYS'][$keyArray[2]] && !$this->exists($this->source['TABLES'][$keyArray[0]]['FOREIGN_KEYS'][$keyArray[2]].'/'.$value)) {
                  echo "<P><B>SQL Error:</B> The value &quot;".$value."&quot; for attribute &quot;".$keyArray[2]."&quot; refers to a none existing entry in table &quot;".$this->source['TABLES'][$keyArray[0]]['FOREIGN_KEYS'][$keyArray[2]]."&quot;. Insert/Update operation aborted.</P>";
                  return false;
                }

            break;

            # error
            default:
              return false;
            break;

          }

    } else { # $value is not set - since there no value to set this will be a simple read operation
      $queryType = 1;
    }

    $this->last_selected_table = $keyArray[0];

    # 5) build sql-statement

    switch ($queryType) {

     case 1:
       $sqlStmt = "SELECT";
       if (empty($keyArray[2])) {
         $sqlStmt .= " * ";
       } else {
         $sqlStmt .= " ".$keyArray[2]." ";
       }
       $sqlStmt .= " FROM ".$keyArray[0]." ";
     break;

     case 2:
       $sqlStmt = "UPDATE ".$keyArray[0]." SET ";
       if ($returnedType == 2)
       {
         if (!is_array($value)) return false;
         for ($i=0; $i<count($value);$i++) {
            $sqlStmt .= key($value)." = '". current($value)."'";
            if ($i+1<count($value)) {
              $sqlStmt .= ", ";
            }
            next($value);
         }
         $sqlStmt .= " ";
       }
       else
       {
         $sqlStmt .= $keyArray[2]." = '".$value."' ";
       }
     break;

     case 3:
       $sqlStmt = "INSERT INTO ".database_prefix.$keyArray[0]." SET ";
       if ($returnedType != 2) {
         echo "<P><B>SQL ERROR:</B> Invalid insert operation. You may only insert rows (not fields or tables).</P>";
         return false;
       }

       $temp = $this->source['TABLES'][$keyArray[0]]['PRIMARY_KEY'];

       if (!isset($value[$temp]) && $keyArray[1]) {
         $value[$temp] = $keyArray[1];
       }
       for ($i=0; $i<count($value);$i++) {
         $sqlStmt .= key($value)." = \"". current($value)."\"";
         if ($i+1<count($value)) {
           $sqlStmt .= ", ";
         }
         next($value);
       }
       $sqlStmt .= " ";
       unset($temp);
     break;
     
     default:
       return false;
     break;

    }

    # 6) resolve joins

    if ($queryType < 3 && $queryType > 0 && $useWildcard < 2) {
      $where = (!empty($keyArray[1])) ? $this->source['TABLES'][strtolower($keyArray[0])]['PRIMARY_KEY'] ." = '".addslashes($keyArray[1])."' " : "";
    }

    if ($queryType == 1) {
        $JOIN  = array();
        if (isset($this->joins[$keyArray[0]])) $JOIN  = $this->joins[$keyArray[0]];
        settype($JOIN, "array");

        foreach ($JOIN as $a => $b) {

          if (count($JOIN) == 1 && !$b['TKEY'] && !$b['FKEY']) {
            $sqlStmt .= "NATURAL JOIN ".database_prefix.$b['TABLE']." ";
          } else {
            $sqlStmt .= ", ".database_prefix.$b['TABLE']." ";
            if ($b['FKEY'] && $b['TKEY']) {
              $where .= ( ($where) ? "AND " : "" ).database_prefix.$keyArray[0].'.'.$b['FKEY'].' = '.database_prefix.$b['TABLE'].'.'.$b['TKEY'].' ';
            } else if ($b['FKEY']) {
              $where .= ( ($where) ? "AND " : "" ).database_prefix.$keyArray[0].'.'.$b['FKEY'].' = '.database_prefix.$b['TABLE'].'.'.$b['FKEY'].' ';
            }
          }
        }
    }

    # 7) resolve search clause

    if (!empty($search)) {
      $where .= $this->computeSearchString($keyArray[0], $search);
    }
    $sqlStmt .= ( (!empty($where)) ? "WHERE $where " : " " ).$this->getFilter($keyArray[0]);

    if ($queryType == 2 || $queryType == 3) {
      array_push($this->content,$sqlStmt);
      return true;
    } else if ($queryType == 1) {

    if (!$result = @ mysql_query($sqlStmt, $this->database)) {
      echo "<P><B>SQL WARNING:</B> Query &quot;".$sqlStmt."&quot; on database failed</P>";
    } else {
      $REF = array();
      $id  = $this->source['TABLES'][strtolower($this->getTable())]['PRIMARY_KEY'];

      while($row = @ mysql_fetch_array($result)) {
        foreach ($row as $a => $b) {
          if (!is_int($a) && $b) {
              switch ($returnedType) {
                case 1:
                  $REF[strtoupper($row[$id])][strtoupper($a)] = stripslashes($b);
                break;
                case 2:
                  $REF[strtoupper($a)] = stripslashes($b);
                break;
                case 3:
                  $REF = $b;
                break;
                default:
                  return false;
                break;
              }
            }
          }
        }
        @mysql_freeresult($result);
        return $REF;
      }
      return false;
    } else {
      return false;
    }
  }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

  /* public String */ function getFilter(/* String */ $table = "") {
    settype($table, "string");
    $table = strtolower($table);

    if ($table == "" || $table == "*") {
      if (!$this->last_selected_table) {
        return false;
      } else {
        $table = $this->last_selected_table;
      }
    }

    return (isset($this->filter[$table])) ? $this->filter[$table] : $this->filter["DEFAULT"];
  }

  /* public void */ function setFilter(/* String */ $table, /* String */ $filter) {
    settype($table, "string");
    settype($filter, "string");
    $table = strtolower($table);
    $filter = strtolower($filter);

    if (! preg_match("/;/", $filter)) {
      $filter = preg_replace("/;.*/", "", $filter);
    }

    if ($table == "" || $table == "*") {
      if (!$this->last_selected_table) {
        return false;
      } else {
        $table = $this->last_selected_table;
      }
    } else {
      $this->last_selected_table = $table;
    }

    $this->filter[$table] = $filter;
  }

#   /* protected String */ function getOption(/* String */ $table = "", /* String */ $option = "PRIMARY_KEY") {
#     settype($table, "string");
#     settype($option, "string");
# 
#     $table  = strtolower($table);
#     $option = strtolower($option);
# 
#     if ($table == "" || $table == "*") {
#       if (!$this->last_selected_table) {
#         return false;
#       } else {
#         $table = $this->last_selected_table;
#       }
#     }
# 
#     return $this->options['TABLES'][$table][$option];
#   }
#
#   /* protected void */ function setOption(/* String */ $table = "", /* String */ $option, /* mixed */ $value) {
#     settype($table,  "string");
#     settype($option, "string");
# 
#     $table  = strtolower($table);
#     $option = strtolower($option);
# 
#     if ($table == "" || $table == "*") {
#       if (!$this->last_selected_table) {
#         return false;
#       } else {
#         $table = $this->last_selected_table;
#       }
#     } else {
#       $this->last_selected_table = $table;
#     }
#
#     $this->options['TABLES'][$table][$option] = $value;
#   }

  /* public String */ function getTable() {
    return $this->last_selected_table;
  }

  /* public int */ function length(/* String */ $table = "", /* String */ $search = "") {
    settype($table, "string");
    settype($search, "string");

    $table = strtolower($table);

    if (!$this->database)          return false;
    if (!$this->source)            return false;

    if ($table == "" || $table == "*") {
      if (!$this->last_selected_table) {
        return false;
      } else {
        $table = $this->last_selected_table;
      }
    }

    if ($search) {
      if (! $search = $this->computeSearchString($table, $search)) return false;
    }

    if (!$this->exists($table)) return 0;

    $result = @ mysql_query("SELECT COUNT(*) FROM ".$table. ( ($search) ? " WHERE ".$search : "" ) );
    $length = @ mysql_fetch_array($result);
    @ mysql_freeresult($result);

    $length = $length[0];
    settype($length, "integer");
    return $length;
  }

  /* public boolean */ function isEmpty(/* String */ $table = "") {
    settype($table, "string");
    $table = strtolower($table);

    if ($table == "" || $table == "*") {
      if (!$this->last_selected_table) {
        return false;
      } else {
        $table = $this->last_selected_table;
      }
    }

    return ($this->length($table) == 0);
  }

  /* public boolean */ function exists(/* String */ $key = "") {
    settype($key, "string");
    $key = preg_replace("/\/(\*)?$/", "", $key);
    $key = strtolower($key);

    if ($key == "" || !$this->exists) {
      return $this->exists && $this->database;
    } else {
      $key = strtolower($key);
      $key = explode('/', $key);
      /* int */ $result = 0;
      if (count($key) == 1) {
        return isset($this->source['TABLES'][$key[0]]);
      } else if (count($key) == 2) {
        $result = @ mysql_query("SELECT * FROM ".$key[0]." WHERE ".$this->source['TABLES'][$key[0]]['PRIMARY_KEY']." = '".$key[1]."'");
      } else if (count($key) > 2) {
        $result = @ mysql_query("SELECT ".$key[2]." FROM ".$key[0]." WHERE ".$this->source['TABLES'][$key[0]]['PRIMARY_KEY']." = '".$key[1]."'");
      } else {
        return false;
      }
      $a = @ mysql_fetch_array($result);
      @ mysql_freeresult($result);

      $a = count($a) -1;
      settype($a, "boolean");
      return $a;
    }
  }

  /* public boolean */ function is_writeable() {
    return $this->exists() && !$this->source['READONLY'];
  }

/**********************************************************************************************
*  Sonstige Funktionen
**********************************************************************************************/

  /* private String */ function computeSearchString($table, $search) {
    settype($table, "string");
    settype($search, "string");

    $table = strtolower($table);

    if (!preg_match("/^((, ?)?([\w\d-_\.])+=([\w\d-_\. ])+)*$/i", $search)) return false;

    $search = preg_split("/, ?/", $search);
    settype($search, "array");
    foreach ($search as $a => $b) {
      $search[$a] = explode("=", $b);
    }

    $result = "";

    if (count($search)) {
       foreach ($search as $a => $b) {
         if (is_array($b) && count($b) == 2 && $b[0] && isset($b[1])) {

           $b[0] = strtolower($b[0]);

         # catch exceptions
               if ($this->source['USE_STRICT'] && strcasecmp($this->source['TABLES'][$table]['PRIMARY_KEY'],$b[0]) == 0) {
                 echo "<P><B>SQL ERROR:</B> Invalid SQL statement. You are trying to search for a primary key. This is not allowed, since it might cause results wether to be ambigious or empty. Try setting &quot;USE_STRICT&quot; to &quot;false&quot; if you wan't to turn this message off and continue without checking.</P>";
                 return false;
               }
               if ($this->source['USE_STRICT'] && !isset($this->source['TABLES'][$table]['CONTENT'][$b[0]]) && !isset($this->source['TABLES'][$table]['FOREIGN_KEYS'][$b[0]])) {
                 echo "<P><B>SQL ERROR:</B> Field &quot;".$b[0]."&quot; does not exist in table &quot;".$table."&quot;. Perhaps your structure file is incomplete. Try setting &quot;USE_STRICT&quot; to &quot;false&quot; if you wan't to turn this message off and continue without checking.</P>";
                 return false;
               }
           if (isset($this->source['TABLES'][$table]['FOREIGN_KEYS'][$b[0]])) {
             $result .= ( ($result) ? "AND " : "" ).$b[0]." = '".addslashes($b[1])."' ";
           } else {
             $result .= ( ($result) ? "AND " : "" ).$b[0]." LIKE '%".addslashes($b[1])."%' ";
           }
         }
       }
    }

    return $result;
  }

  /* public boolean */ function create(/* String */ $sqlFile = "") {
    settype($sqlFile, "String");
    if ($this->source['READONLY'] || ($sqlFile && !is_readable($sqlFile))) {
      return false;
    } else if ($sqlFile) {
      $raw_data = @fread(@fopen($sqlFile, 'r'), @filesize($sqlFile));
      # Entferne Kommentare und leere Zeilen
      $raw_data = preg_replace("/\s*\#[^\n]*/i", "", $raw_data);
      $raw_data = preg_replace("/\s*\-\-[^\n]*/i", "", $raw_data);
      $raw_data = preg_replace("/\n/", "", $raw_data);

      $this->content = array_merge($this->content, explode(";", $raw_data));
      return $this->write();
    } else {
      return true;
    }
  }

  /* public String */ function toString(/* String */ $table = "") {
    settype($table, "string");
    $table = strtolower($table);

    if (!$this->database || !$this->source) {
      return "No Database Connection: Database structure file not available or not loaded";
    }

    if ($table == "" || $table == "*") {
      if (!$this->last_selected_table) {
        return false;
      } else {
        $table = $this->last_selected_table;
      }
    }

    $text = "";

    $a = $this->get($table);
    foreach ($a as $k => $e) {
      for ($i=0; $i<count($e);$i++) {
        $b = current($e);
        settype($b, "string");
        $text .= $b;
        if (next($e)) {
          $text .= ", ";
        }
      }
      $text .= "\n";
    }

    return $text;
  }

}

$copyright = urldecode("%3Cp%20class%3D%22KOMMENTAR%22%20style%3D%22text-align%3A%20center%22%3EWebTools%20powered%20by%20%3CA%20HREF%3D%22http%3A%2F%2Fwww.All-Community.de%22%20target%3D%22_blank%22%20title%3D%22Die%20Community%20der%20Webmaster%22%3E%3Cspan%20style%3D%22color%3A%236495ED%22%3Ewww.%3C%2Fspan%3E%3Cspan%20style%3D%22color%3A%23FFA500%22%3E%20All%20-%20Community%20%3C%2Fspan%3E%3Cspan%20style%3D%22color%3A%236495ED%22%3E.de%3C%2Fspan%3E%3C%2FA%3E");

//  2005, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
