<?php

/*
   Das Editieren dieser Datei ist nicht gestattet!
   Editing of this file is not allowed!
*/

class secureInputStream extends inputStream {

   var $source = "";
   var $content;

   var $options = array();

   function secureInputStream($filename) {
     if (!file_exists($filename) || !is_readable($filename)) {
       $this->source = NULL;
       $this->exists = false;
     } else {
       $this->attributes['MTIME'] = date("d.m.Y",filemtime($filename));
       $this->attributes['ATIME'] = date("d.m.Y H:i:s",fileatime($filename));
       $this->attributes['CTIME'] = date("d.m.Y",filectime($filename));
       clearstatcache();
       $this->exists = true;
     }
     global $REMOTE_ADDR; if (isset($REMOTE_ADDR)) { $this->attributes['REMOTE_ADDR'] = $REMOTE_ADDR; }
     $this->filename = $filename;
   }

   function read() {
     if (!is_readable($this->filename)) {
       $this->exists  = false;
       return false;
     } else {
       $this->content = $this->source = file($this->filename);
       $this->options = $this->attributes;
       $this->exists  = true;
       return true;
     }
   }

   function failSafeRead() {
     for ($i=0; $i<3; $i++) {
       if ($this->read()) {
         return true;
         break;
       } else {
         sleep(0.5);
       }
     }
     return false;
   }

   function get() {
     if (!$this->isEmpty()) {
       return implode("", $this->content);
     } else {
       return "";
     }
   }

   function toString() {     # overload this method for each sub class
     if (!$this->exists()) {
       return "File ".$this->filename." does not exist\n";
     } elseif ($this->isEmpty()) {
       return "File ".$this->filename." is wether empty or not loaded\n";
     } else {
       return $this->get();
     }
   }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

   function isEmpty() {
     return empty($this->source);
   }

   function checksum() {
     return crc32($this->source);
   }

   /* public void */ function reset() {
     $this->content=$this->source;
     $this->options=$this->attributes;
   }

   /* public void */ function close() {
     foreach ($this as $key=>$element) {
       unset($this->$key);
     }
   }

}

//  2005, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
