<?php

class guestbook extends serializeableObject {

   var $id     = "gbuch";
   var $page   = 0;
   var $target = "";
   var $php_self = "";
   var $next_action = "show";
   var $remote_addr = "";

/*********************************************************************************************/

   function guestbook($ARGS) {
      @session_start();
      global $lcn_note, $PROGRAM, $REMOTE_ADDR;

      # <... Typsicherheit herstellen
      settype($ARGS, "array");
      settype($lcn_note, "string");
      # ENDE ...>

      if (isset($ARGS['id']) && $ARGS['id'])        $this->id          = strtolower($ARGS['id']);
      if (isset($ARGS['page']) && $ARGS['page']>0)  $this->page        = $ARGS['page'];
      if (isset($ARGS['target']) && $ARGS['target'])$this->target      = $ARGS['target'];
                                                    $this->php_self    = $PROGRAM->getRegistryKey("PHP_SELF");
      if (isset($ARGS['action']) && $ARGS['action'])$this->next_action = $ARGS['action'];
                                                    $this->remote_addr = $REMOTE_ADDR;

      # Initialisiere
      $PROGRAM->setRegistryKey("ID",         $this->id);
      $PROGRAM->setRegistryKey("PAGE",       $this->page);
      $PROGRAM->setRegistryKey("TARGET",     $this->target);
      $PROGRAM->setRegistryKey("REMOTE_ADDR",$this->remote_addr);
      $dir = $PROGRAM->getRegistryKey("PROFILE/SMILEYDIR");
      if (is_dir($dir)) loadSmilies($dir);
   }

/*********************************************************************************************/

    function getBookEntries(/* boolean */ $extend) {
      settype($extend, "boolean");
      global $PROGRAM;

        # <... neue Gstebcher nicht anzeigen, falls Auto-Option deaktiviert ist
        if ($this->isOffspring() && !$PROGRAM->getRegistryKey("PROFILE/AUTO")) {
          $PROGRAM->meldung("fehler", "4041", "show");
        }
        # ...>

      $REF = array();
      if (!$extend) {
          $REF              += $this->genButtonList("show");
          $REF              += $this->genButtons("show",$this->page);
          $REF['BESCHREIBUNG'] = $PROGRAM->getRegistryKey("LANGUAGE/DESCR_SHOW");
          $PROGRAM->setEvent("show");
      } else {
          $REF              += $this->genButtonList("details");
          $REF              += $this->genButtons("details",$this->page);
          $REF['BESCHREIBUNG'] = $PROGRAM->getRegistryKey("LANGUAGE/DESCR_DETAILS");
          $PROGRAM->setEvent("details");
      }

      $profiles_installed = false;
      $profiles_installed = $PROGRAM->getRegistryKey("INSTALLED_PLUGINS/USER_PROFILES");

        # <... Besucherzhler
        $REF['BESUCHER'] = counter($this->id, $PROGRAM->getRegistryKey("TMP"));
        # ...>

      $myGB = $PROGRAM->registry->get("gbuch");
      $myGB->read();
      $sum = $myGB->length();
      
      $entPerPage          = $PROGRAM->getRegistryKey("PROFILE/ENTPERPAGE");
      $kommentar_title     = $PROGRAM->getRegistryKey("LANGUAGE/TITLE_KOMMENTAR");
      $kommentar_einfuegen = $PROGRAM->getRegistryKey("LANGUAGE/KOMMENTAR");
      $kommentar_ersetzen  = $PROGRAM->getRegistryKey("LANGUAGE/TITLE_KOMMENTAR_ERSETZEN");
      $loeschen_title      = $PROGRAM->getRegistryKey("LANGUAGE/TITLE_LOESCHEN");
      $loeschen_text       = $PROGRAM->getRegistryKey("LANGUAGE/LOESCHEN");

      $REF["PAGE.FIRST"] = ($this->page+$entPerPage > $sum) ? $sum : $this->page+$entPerPage;
      $REF["PAGE.LAST"]  = $sum;

      for ($j=$this->page;$j<$sum && $j<($this->page+$entPerPage); $j++) {

        $REF['ENTRY'][$j] = $myGB->get($j);
        $REF['ENTRY'][$j]['IS_REGISTERED'] = $profiles_installed && !empty($REF['ENTRY'][$j]['IS_REGISTERED']);

        # <... Prfe Werte auf Gltigkeit
        if (preg_match("/^\d+$/", $REF['ENTRY'][$j]['DATUM'])) {
          $REF['ENTRY'][$j]['DATUM'] = '<script type="text/javascript" language="JavaScript">date=new Date('.$REF['ENTRY'][$j]['DATUM']."000); document.write(".$PROGRAM->getRegistryKey("DATE/".$PROGRAM->getRegistryKey("PROFILE/TIMEFORMAT")).");</script>";
        }
    		if (!isset($REF['ENTRY'][$j]['KOMMENTAR'])) {
          $REF['ENTRY'][$j]['KOMMENTAR'] = '<a title="'.$kommentar_title.'" target="_self" href="'.$this->genLink("comment",$j,'*').'">'.$kommentar_einfuegen.'</a>';
        } else {
          $REF['ENTRY'][$j]['KOMMENTAR'].= '<div><a title="'.$kommentar_title.'" target="_self" href="'.$this->genLink("comment",$j,'*').'">'.$kommentar_ersetzen.'</a></div>';
        }
    		if (!isset($REF['ENTRY'][$j]['LOESCHEN'])) {
          $REF['ENTRY'][$j]['LOESCHEN'] = '<a title="'.$loeschen_title.'" target="_self" href="'.$this->genLink("delete",$j,'*').'">'.$loeschen_text.'</a>';
        }
        # Prfe Werte auf Gltigkeit ...>
      } # end for

      # <... Berechne Vor- / Zurck-Buttons
      if ($this->page > 0) {
        $REF['ZURUECK'] = '<a title="'.$PROGRAM->getRegistryKey("LANGUAGE/TITLE_ZURUECK").'" href="'.$this->genLink("*","*",(($this->page-$entPerPage>0)?$this->page-$entPerPage:0)).'">&#9668;&nbsp;'.$PROGRAM->getRegistryKey("LANGUAGE/ZURUECK").'</a>&nbsp;' . "\n";
      }
      if ($this->page+$entPerPage < $sum) {
        $REF['VOR'] = '&nbsp;<a title="'.$PROGRAM->getRegistryKey("LANGUAGE/TITLE_VOR").'" href="'.$this->genLink("*","*",($this->page+$entPerPage)).'">'.$PROGRAM->getRegistryKey("LANGUAGE/VOR").'&nbsp;&#9658;</a>' . "\n";
      }
      $title_liste = $PROGRAM->getRegistryKey("LANGUAGE/TITLE_LISTE");
      $REF['LISTE'] = "";
      if ($sum > ($entPerPage*2)) {
        $lastPage = ceil($sum/$entPerPage);
        $dots     = false;
        for($k=0;$k<$lastPage;$k++) {
          $first = ($k*$entPerPage);
          $last  = ((($k+1)*$entPerPage < $sum) ? ($k+1)*$entPerPage : $sum);
          if ($sum > 10 * $entPerPage && $k > 1 && $k < $lastPage - 2) {
            if (!$dots) {
              $dots = true;
              $REF['LISTE'] .= '&nbsp;... ' . "\n";
            }
          } else if ($this->page >= ($k*$entPerPage) && $this->page < (($k+1)*$entPerPage) ) {
            $REF['LISTE'] .= '&nbsp;['.($first+1).'-'.$last.'] ' . "\n";
          } else {
            $REF['LISTE'] .= '&nbsp;<a title="'.$title_liste.'"  href="'.$this->genLink("*","*",$first).'">['.($first+1).'-'.$last.']</a> ' . "\n";
          }
        }
        unset($lastPage);
        unset($first);
        unset($last);
        unset($dots);
      }
      # ...>

      $PROGRAM->registry->merge("", $REF);
    }

    function get_new() {
      global $PROGRAM;

      $REF = array();
      $REF                += $this->genButtonList("new");
      $REF                += $this->genButtons("new","");
      $REF['BESCHREIBUNG'] = $PROGRAM->getRegistryKey("LANGUAGE/DESCR_NEW");
      $REF['SMILIES']      = $this->genSmilies();
      $REF['FORM_PARAMS']  = $this->genFormParams("add",$this->target);
      $PROGRAM->registry->merge("", $REF);
      $PROGRAM->setEvent("add");
    }

    function get_comment() {
      global $PROGRAM;
      if (isset($this->target)) settype($this->target, "integer");

      if (isset($this->target) && $this->target>-1) {

          $REF = array();
          $REF                += $this->genButtonList("new");
          $REF                += $this->genButtons("new","");
          $REF['BESCHREIBUNG'] = $PROGRAM->getRegistryKey("LANGUAGE/DESCR_KOMMENTAR");
          $REF['FORM_PARAMS']  = $this->genFormParams("addcomment",$this->target);
          $REF['SMILIES']      = $this->genSmilies();
          $PROGRAM->registry->merge("", $REF);
          $PROGRAM->setEvent("show");

      } else {
        $PROGRAM->meldung("fehler", "UNGUELTIGE_EINGABE", "show");
      }

    }

    function get_delete() {
      global $PROGRAM;
      if (isset($this->target))  settype($this->target, "integer");

      if (isset($this->target) && $this->target>-1) {

          $REF = array();
          $REF                += $this->genButtonList("");
          $REF                += $this->genButtons("","");
          $REF['BESCHREIBUNG'] = $PROGRAM->getRegistryKey("LANGUAGE/DESCR_LOESCHEN");
          $REF['FORM_PARAMS']  = $this->genFormParams("deleteentry",$this->target);
          $PROGRAM->registry->merge("", $REF);
          $PROGRAM->setEvent("deleteentry");

      } else {
        $PROGRAM->meldung("fehler", "UNGUELTIGE_EINGABE", "show");
      }

    }

/*********************************************************************************************/

    function set_delete() {
      global $PROGRAM;
      if (isset($this->target)) { settype($this->target, "integer"); };

      if (isset($this->target) && $this->target > -1) {

          $myGB = $PROGRAM->registry->get("gbuch");
          $myGB->read();

          if (!$myGB->remove($this->target)) { $PROGRAM->meldung("fehler", "500", "delete"); };
          if (!$myGB->failSafeWrite())       { $PROGRAM->meldung("fehler", "500", "delete"); };
          $PROGRAM->meldung("danke", "200", "show");

      } else {
        $PROGRAM->meldung("fehler", "UNGUELTIGE_EINGABE", "show");
      }
    }                             	

    function set_comment($new_comment) {
      global $PROGRAM;
      if (isset($this->target)) { settype($this->target, "integer"); };

      if (isset($this->target) && $this->target > -1) {

          $myGB = $PROGRAM->registry->get("gbuch");
          $myGB->read();

          $REF = $myGB->getRawData($this->target);
          $REF['KOMMENTAR'] = $new_comment;
          $myGB->replace($this->target,$REF);

          if (!$myGB->failSafeWrite()) {
            $PROGRAM->meldung("fehler", "500", "comment");
          } else {
            $PROGRAM->meldung("danke", "200", "show");
          }

      } else {
        $PROGRAM->meldung("fehler", "UNGUELTIGE_EINGABE", "show");
      }

    }

    function set_new($INPUT) {
      global $PROGRAM;

      # <... neue Gstebcher nicht anzeigen, falls Auto-Option deaktiviert ist
      if ($this->isOffspring() && !$PROGRAM->getRegistryKey("PROFILE/AUTO")) { $PROGRAM->meldung("fehler", "4041", "show"); }
      # ...>

      # <... Protection
      $INPUT['form_pflichtfelder'] = (isset($INPUT['form_pflichtfelder'])) ? explode(" ", strtolower($INPUT['form_pflichtfelder'])) : array();
      for ($i=0;$i<count($INPUT['form_pflichtfelder']);$i++) if ($INPUT[$INPUT['form_pflichtfelder'][$i]]=="") $PROGRAM->meldung("hinweis", "FEHLER", "new");

      $myFlood = $PROGRAM->registry->get("flood");
      $myFlood->setMax($PROGRAM->getRegistryKey("PROFILE/FLOODING"));
      if ($myFlood->isBlocked()) { $PROGRAM->meldung("hinweis", "FLOODING", "new"); };

      unset($INPUT['form_pflichtfelder']);
      unset($INPUT['id']);
      unset($INPUT['page']);
      unset($INPUT['action']);
      unset($INPUT['target']);
      unset($INPUT[strtolower(session_name())]);
      # ...>      

      if (strcasecmp($PROGRAM->getRegistryKey("SESSION_USER_ID"), $INPUT['name']) == 0) {
       $INPUT['IS_REGISTERED'] = true;
      } else {
       $INPUT['IS_REGISTERED'] = false;
      }
      $INPUT['DATUM']       = time();
      $INPUT['REMOTE_ADDR'] = $this->remote_addr;

      $myGB = $PROGRAM->registry->get("gbuch");

      if (!$myGB->read()) {
        if (!$myGB->create()) {
          $PROGRAM->meldung("fehler", "500", "new");
        }
      }

      # <... Flooding Protection
        $temp1 = $myGB->get(0); unset($temp1['DATUM']);
        $myGB->insert($INPUT);
        $temp2 = $myGB->get(0); unset($temp2['DATUM']);
        if($temp1 == $temp2) { $PROGRAM->meldung("hinweis", "NOSPAM", "new"); }
        if($myFlood->getMax()>0)  { $myFlood->set(); };
      # ...>

      if ($myGB->failSafeWrite()) {

         # <... Send Mail
          if (trim($INPUT['mail'])!= "" && $PROGRAM->getRegistryKey("PROFILE/SENDMAIL")) {
            $this->send_mail($INPUT['name']."<".$INPUT['mail'].">",$PROGRAM->getRegistryKey("SETTINGS/danke.mail"),$INPUT);
          }
          if ($PROGRAM->getRegistryKey("PROFILE/MYMAIL") && $PROGRAM->getRegistryKey("PROFILE/NOTIFICATION")) {
            $this->send_mail($PROGRAM->getRegistryKey("PROFILE/MYMAIL"),$PROGRAM->getRegistryKey("SETTINGS/benachrichtigung.mail"),$INPUT);
          }
          # ...>
        $PROGRAM->meldung("danke", "200", "show");
      } else { $PROGRAM->meldung("fehler", "500", "new"); }
    }


/*********************************************************************************************/

   function isOffspring() {
      global $PROGRAM;
      return (!file_exists($PROGRAM->registry->files['gbuch']->filename)
              && !file_exists($PROGRAM->registry->files['CONFIG']->filename.$this->id.".cfg")
              && $this->id != 'gbuch');
   }

   function genLink($action, $target, $page) {
      settype($action, "string");
      settype($target, "string");
      settype($page, "string");

      if ($action=="*") $action = $this->next_action;
      if ($target=="*") $target = $this->target;
      if ($page=="*")   $page   = $this->page;
      return $this->php_self."?action=".$action."&amp;page=".$page."&amp;id=".$this->id."&amp;target=".$target.( (session_id()) ? "&amp;".session_name()."=".session_id() : '' );
   }

   function genButtonList($action) {
      settype($action, "string");
      $action = strtoupper($action);
      global $PROGRAM;
      
      $REF = array();
      $vers = array("",1);
      $dir = $PROGRAM->getRegistryKey("LANGUAGEDIR");

      if ($action != "") {
          for ($i=0;$i<count($vers);$i++) {
            $map = implode("", file($dir.$PROGRAM->getRegistryKey("TMPL/$action".current($vers)."/MAP")));
            $REF["SCHALTER".current($vers)] = $map.'<img alt="" src="'.$dir.$PROGRAM->getRegistryKey("TMPL/$action".current($vers)."/SCHALTER").
                                              '" border=0 usemap="#myMap">';
            next($vers);
          }
      }

      return $REF;
   }

   function genButtons($action,$target) {
      settype($action, "string");
      settype($target, "string");
      global $PROGRAM;

      $REF = array();
      $vers = array("",1,2);
      $btns = array("SHOW","DETAILS","NEW");
      $dir = $PROGRAM->getRegistryKey("LANGUAGEDIR");

      for ($x=0;$x<count($btns);$x++) {
          for ($i=0;$i<count($vers);$i++) {
            $href = $this->genLink(current($btns),(current($btns)==$action) ? $target : '','*');                                
            $REF[current($btns).current($vers)] = '<a href="'.$href.'" '.
                                             'title="'.$PROGRAM->getRegistryKey("LANGUAGE/TITLE_".current($btns)).'">'.
                                             '<img src="'.$dir.$PROGRAM->getRegistryKey("TMPL/".strtoupper(current($btns)).current($vers)."/".
                                             ( (strcasecmp(current($btns),$action)) ? 'OFF' : 'ON' )).'" border=0></a>';
            if ($i==0) $PROGRAM->setRegistryKey("GB_LINK_".strtoupper(current($btns)), $href);
            next($vers);
          }
          reset($vers);
          next($btns);
      }
      return $REF;
   }

   function genFormParams($action,$target) {
      settype($action, "string");
      settype($target, "string");
      global $PROGRAM;

      $text = '<input type="hidden" name="target" value="'.$target.'">'.
              '<input type="hidden" name="id" value="'.$this->id.'">'.
              '<input type="hidden" name="action" value="'.$action.'">'.
              ( (session_id()) ? '<input type="hidden" name="'.session_name().'" value="'.session_id().'">' : '' );
      return $text;
   }

   function genSmilies() {
      global $smilies,$PROGRAM;
      $TABLE_smilies = "";
      $title_smilies = $PROGRAM->getRegistryKey("LANGUAGE/TITLE_SMILIES");
      $smileyDir     = $PROGRAM->getRegistryKey("PROFILE/SMILEYDIR");

      for ($j=0;$j<count($smilies);$j++) {
        if ($j % 5 == 0 && $j > 0) { $TABLE_smilies .= '</tr><tr>'; }
        $TABLE_smilies .= '<td align=center valign=middle><a title="'.$title_smilies.'" href="javascript://"><img hspace=3 onClick="document.eintrag.nachricht.value+=\':'.$smilies[$j].':\'" border=0 src="'.$smileyDir.$smilies[$j].'.gif"></a></td>'."\n";
      }

      return $TABLE_smilies;
   }

   function send_mail($empfaenger,$template,$INPUT) {
      global $PROGRAM;                                              	
      $heute                = getdate();   
      $mail                 = new mailer($template);
      $mail->read();
      $mail->betreff        = $PROGRAM->getRegistryKey("LANGUAGE/MAIL_SUBJECT")."<br>\n";
      $mail->header         = "From:".$PROGRAM->getRegistryKey("PROFILE/NOREPLY")."<br>\n";
      $mail->options       += $PROGRAM->getRegistryKey("*");
      $mail->options       += $INPUT;
      $mail->options['DATUM'] = $heute['mday'] . '.' . $heute['mon'] . '.' . $heute['year'];
      $mail->send($empfaenger);
   }

} // class

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
