<?php

/* public */ class plugin_user_admin extends plugin {

  /* private user_admin */ var $file;

  /* constructor */ function plugin_user_admin($plugin_name) {
    settype($plugin_name,"string");
    $this->plugin_name = $plugin_name;
    global $PROGRAM;
    $this->file = new user_admin($PROGRAM->plugins->get($this->plugin_name,"USER_DB"));
    $dir = $PROGRAM->getRegistryKey("PROFILE/SMILEYDIR");
    if (is_dir($dir)) loadSmilies($dir);
  }

  /* public void */ function listener(/* String */ $event, /* Hashtable */ $ARGS) {
     settype($event, "string");
     settype($ARGS, "array");
     $event = strtolower($event);

     if (!$this->file->isEmpty()) {

       global $PROGRAM;
       $PROGRAM->setRegistryKey("ID",$ARGS['id']);
       $PROGRAM->setRegistryKey("FORM_PARAMS", '
      <input type="hidden" name="target" value="%TARGET%">
      <input type="hidden" name="%SESSION_NAME%" value="%SESSION_ID%">
      <input type="hidden" name="id" value="%ID%">');

       switch ($event) {

         case "get_user_list":
                $PROGRAM->registry->mount("language_user_file");
                return $this->file->get_user_configuration();
         break;

         case "get_user_edit":
                $PROGRAM->registry->mount("language_user_file");
                return $this->file->get_user_edit($ARGS['target']);
         break;

         case "set_user_edit":
                return $this->file->set_user_edit($ARGS['target'],$ARGS);
         break;

         case "get_user_delete":
                $PROGRAM->registry->mount("language_user_file");
                return $this->file->get_user_delete($ARGS['target']);
         break;

         case "set_user_delete":
                return $this->file->set_user_delete($ARGS['target']);
         break;

         case "get_user_new":
                $PROGRAM->registry->mount("language_user_file");
                return $this->file->get_user_new($ARGS['target']);
         break;

         case "set_user_new":
                if ($this->file->set_user_new($ARGS['target'],$ARGS))
                {
                  $PROGRAM->meldung("danke", "200", "index");
                  return false;
                } else {
                  $PROGRAM->meldung("fehler", "500", "index");
                  return false;
                }
         break;

         case "set_user_pwd":
                $PROGRAM->registry->mount("language_user_file");
                if ($this->file->set_user_pwd($ARGS['target']))
                {
                  $PROGRAM->meldung("danke", "200", "index");
                  return false;
                } else {
                  $PROGRAM->meldung("fehler", "500", "index");
                  return false;
                }
         break;

         /* <FORMULAR> Mail-Authentifizierung */
         case "get_user_mail":
               if (!$PROGRAM->plugins->getRegistryKey($this->plugin_name, "ALLOW_CREATE_USER"))
               {
                 $PROGRAM->meldung("fehler", "ungueltige_eingabe", "");
                 return false;
               }

               $PROGRAM->registry->mount("language_user_file");
               $PROGRAM->setRegistryKey("ACTION_PARAMS", '<input type="hidden" name="action" value="SET_USER_MAIL">');
         break;

         /* <SESSION-ERZEUGEN> Mail-Authentifizierung */
         case "set_user_mail":
               if (!$PROGRAM->plugins->getRegistryKey($this->plugin_name, "ALLOW_CREATE_USER"))
               {
                 $PROGRAM->meldung("fehler", "ungueltige_eingabe", "");
                 return false;
               }

               $REF     = array();
               $file    = false;

               if ($this->file->userExists($ARGS['username'])) {

                 $PROGRAM->meldung("hinweis", "user_already_exists", "get_user_mail");
                 return false;

               } else if (!preg_match("/^\S+\@\S+\.\w{2,}$/", $ARGS['mail']) || !preg_match("/^[\w_-]+$/",$ARGS['username'])) {
    
                 // Mailadresse ist ungltig oder leerer Benutzername
                 $PROGRAM->meldung("hinweis", "ungueltige_eingabe", "get_user_mail");
                 return false;
    
               } else {
    
                 $file = $PROGRAM->plugins->get($this->plugin_name,"TEMPDATA");
                 $file->init();
    
                 if (!$file->exists() && !$file->create())
                 {
    
                   $PROGRAM->setRegistryKey("FILE", $file->getFilename());
                   $PROGRAM->meldung("fehler", "file_not_created", "");
                   return false;
    
                 }
                 else
                 {
    
                   $file->insert($ARGS['mail'], $ARGS['username']);
    
                   $REF['WEBSITE_URL'] = $PROGRAM->getRegistryKey("REFERER");
                   $REF['KEY']         = $file->getRecentKey();
                   $REF['MAIL']        = $ARGS['mail'];
                   user_admin::send_mail($ARGS['username'].'<'.$ARGS['mail'].'>',$PROGRAM->getRegistryKey("SETTINGS/USER_CONFIRM_MAIL"),$REF);
    
                   if (!$file->write())
                   {
                     $PROGRAM->setRegistryKey("FILE", $file->getFilename());
                     $PROGRAM->meldung("fehler", "not_writeable", "");
                     return false;
                   }
                   else
                   {
                     $PROGRAM->meldung("danke", 200, "");
                     return false;
                   }
    
                 }
    
               }
         break;

         case "user_authentification":
               if (!$PROGRAM->plugins->getRegistryKey($this->plugin_name, "ALLOW_CREATE_USER"))
               {
                 $PROGRAM->meldung("fehler", "ungueltige_eingabe", "");
                 return false;
               }

               $PROGRAM->registry->mount("language_user_file");
               $REF = array();

               $file = $PROGRAM->plugins->get($this->plugin_name,"TEMPDATA");
               if (!$file->keyExists($ARGS['target']) || !$REF = $file->get($ARGS['target']))
               {

                 $PROGRAM->meldung("fehler", "ungueltige_eingabe", "");
                 return false;

               }
               else
               {
                 $REF1 = $ARGS;
                 $REF1['MAIL'] = $REF['MAIL'];
                 if ($this->file->user_authentification($REF['USERNAME'],$REF1))
                 {
                   $PROGRAM->meldung("hinweis", "first_login", "");
                   return false;
                 }
                 else
                 {
                   $PROGRAM->meldung("fehler", "500", "");
                   return false;
                 }

               }
         break;

         case "set_user_allow_create":
           $myFile = $PROGRAM->plugins->get($this->plugin_name,"CONFIGFILE");
           $myFile->init();
           $myFile->insert(array("ALLOW_CREATE_USER" => (!empty($ARGS['allow_create']) && $ARGS['allow_create']) ? 'true' : 'false'));
           if (!$myFile->write()) {
             $PROGRAM->setRegistryKey("FILE", $myFile->getFilename());
             $PROGRAM->meldung("fehler", "NOT_WRITEABLE", "index");
             return false;                                     
           } else {
             $PROGRAM->meldung("danke", 200, "index");
             return false;
           }
         break;
         
         case "view_profile":
           $PROGRAM->registry->mount("language_user_file");
           return $this->file->get_user($ARGS['target']);
         break;

         case "get_profile_edit":
           $PROGRAM->registry->mount("language_user_file");
           $PROGRAM->setRegistryKey("SMILIES", plugin_user_admin::genSmilies());
           return $this->file->get_user($ARGS['target'], true);
         break;

         case "set_profile_edit":
           return $this->file->set_profile_edit($ARGS);
         break;
         
         default:
                $PROGRAM->registry->mount("language_user_file");
                $USERLIST   = $this->file->getUserList();
                $PROGRAM->setRegistryKey("USERLIST",$USERLIST);
         break;

       } # end switch
     }
     return true;
  }
  
  /* private static String */ function genSmilies() {
    global $smilies,$PROGRAM;
    $TABLE_smilies = "";
    $title_smilies = $PROGRAM->getRegistryKey("LANGUAGE/TITLE_SMILIES");
    $smileyDir     = $PROGRAM->getRegistryKey("PROFILE/SMILEYDIR");

    for ($j=0;$j<count($smilies);$j++) {
      if ($j % 12 == 0 && $j > 0) { $TABLE_smilies .= '</tr><tr>'; }
      $TABLE_smilies .= '<td align="center" valign="middle"><a title="'.$title_smilies.'" href="javascript://"><img hspace="3" onClick="document.eintrag.nachricht.value+=\':'.$smilies[$j].':\'" border="0" src="'.$smileyDir.$smilies[$j].'.gif"></a></td>'."\n";
    }

    return $TABLE_smilies;
  }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
